package com.vaadin.incubator.dashlayout.ui;

import com.vaadin.incubator.dashlayout.client.ui.VDashLayout;
import com.vaadin.terminal.PaintException;
import com.vaadin.terminal.PaintTarget;
import com.vaadin.ui.ClientWidget;
import com.vaadin.ui.Component;
import com.vaadin.ui.VerticalLayout;

@SuppressWarnings("serial")
@ClientWidget(VDashLayout.class)
public class DashLayout extends VerticalLayout {

    public static final int MODE_FULL = VDashLayout.MODE_FULL;
    public static final int MODE_STATIC = VDashLayout.MODE_STATIC;

    private int mode = MODE_STATIC;

    public DashLayout() {
        // Margins are on by default, since they can be controlled from CSS
        // (though the default value in CSS should be zero)
        setMargin(true);
    }

    public void setMode(int mode) {
        if (this.mode != mode) {
            this.mode = mode;
            requestRepaint();
        }
    }

    @Override
    public void paintContent(PaintTarget target) throws PaintException {
        super.paintContent(target);
        target.addAttribute("mode", mode);
    }

    @Override
    public void setExpandRatio(Component c, float ratio) {
        super.setExpandRatio(c, ratio);
        setMode(MODE_FULL);
    }

}
